CHAR_DICT = {32: ' ', 33: '!', 34: '"', 35: '#', 36: '$', 37: '%', 38: '&', 39: "'", 40: '(', 41: ')', 42: '*', 43: '+',
             44: ',', 45: '-', 46: '.', 47: '/', 48: '0', 49: '1', 50: '2', 51: '3', 52: '4', 53: '5', 54: '6', 55: '7',
             56: '8', 57: '9', 58: ':', 59: ';', 60: '<', 61: '=', 62: '>', 63: '?', 64: '@', 65: 'A', 66: 'B', 67: 'C',
             68: 'D', 69: 'E', 70: 'F', 71: 'G', 72: 'H', 73: 'I', 74: 'J', 75: 'K', 76: 'L', 77: 'M', 78: 'N', 79: 'O',
             80: 'P', 81: 'Q', 82: 'R', 83: 'S', 84: 'T', 85: 'U', 86: 'V', 87: 'W', 88: 'X', 89: 'Y', 90: 'Z', 91: '[',
             92: '\\', 93: ']', 94: '^', 95: '_', 96: '`', 97: 'a', 98: 'b', 99: 'c', 100: 'd', 101: 'e', 102: 'f',
             103: 'g', 104: 'h', 105: 'i', 106: 'j', 107: 'k', 108: 'l', 109: 'm', 110: 'n', 111: 'o', 112: 'p',
             113: 'q', 114: 'r', 115: 's', 116: 't', 117: 'u', 118: 'v', 119: 'w', 120: 'x', 121: 'y', 122: 'z',
             123: '{', 124: '|', 125: '}', 126: '~'}

COMMANDS = ['print', 'class', 'def', 'if', 'elif', 'else', 'else:', 'try:', 'except:', 'for', 'while', 'return', 'try',
            'except', 'break', 'pass', 'continue', 'del', 'and', 'or', 'global', 'import', 'from', 'yield', 'raise',
            'lambda', 'assert', 'exec', 'finally', 'in', 'is', 'not']

EXECUTABLES = ['color', 'indent', 'unindent', 'delete', 'comment', 'uncomment', 'show', 'hide', 'mark', 'unmark',
               'find', 'whitespace', 'syntax', 'entry', 'run', 'split', 'splitscreen', 'quit', 'load', 'replace',
               'formatting', 'replace', 'new', 'save', 'saveas', 'revert', 'copy', 'paste', 'collapse', 'uncollapse',
               'undo', 'expand', 'debug', 'cut', 'cut ', 'goto', 'color default', 'protect', 'protect with ',
               'commands', 'isave', 'setcolor', 'timestamp', 'live', 'read', 'prev', 'saveprefs', 'select',
               'deselect', 'strip', 'help', 'previous', 'guide', 'pageguide', 'invert', 'setcolors',
               'acceleration', 'accelerate', 'tab', 'tabs']

EXEC_ABBREVIATED = ['col', 'ind', 'uni', 'del', 'com', 'sho', 'hid', 'mar', 'unm', 'fin', 'whi', 'syn', 'ent', 'run',
                    'spl', 'spl', 'qui', 'loa', 'rep', 'new', 'sav', 'rev', 'cop', 'pas', 'col', 'unc', 'und', 'exp',
                    'deb', 'cut', 'got', 'rea', 'pro', 'isa', 'set', 'tim', 'for', 'liv', 'pre', 'hel', 'pag', 'gui',
                    'sel', 'inv']

# Set Help Guide text
HELP_GUIDE = ["####################################################################:",
              "########################################################## lexed HELP",
              "####################################################################:",
              "",
              "#####################################################################",
              "####################### KEYBOARD NAVIGATION #########################",
              "#####################################################################",
              "arrow keys      Navigate document",
              "---------------------------------------------------------------------",
              "tab key         Indent (tab = 4 spaces)",
              "---------------------------------------------------------------------",
              "control 'w'     Launch SAVE WINDOW, an alternate way to save document",
              "---------------------------------------------------------------------",
              "control 'e'     Launch ENTRY WINDOW, alternate way to enter commands",
              "---------------------------------------------------------------------",
              "control 'd'     If debug mode is on, move to next line with an error",
              "---------------------------------------------------------------------",
              "control 'f'     Launches a search window",
              "---------------------------------------------------------------------",
              "control 'g'     If 'find' has been used, find again (next match)",
              "---------------------------------------------------------------------",
              "control 'n'     Moves to next 'marked' line",
              "---------------------------------------------------------------------",
              "control 'b'     Moves back to previous 'marked' line",
              "---------------------------------------------------------------------",
              "control 'a'     Deselect ALL lines",
              "---------------------------------------------------------------------",
              "control 'p'     Move down ~ 1 page, or one line in splitscreen mode",
              "---------------------------------------------------------------------",
              "control 'u'     Move up ~ 1 page, or one line in splitscreen mode",
              "",

              "#####################################################################",
              "###################### ABOUT INLINE COMMANDS ########################",
              "#####################################################################",
              "Execute commands by typing them on a blank line in the editor and",
              "pressing 'enter'. If there are no blank lines, press the down arrow",
              "and one will be created at the end of the document.",
              "",
              "Commands can optionally be 'protected' with a text string to safeguard",
              "against accidental execution. While protection is on, the protect",
              "string is displayed in the top right corner of the terminal screen.",
              "",
              "                Example: ##::save myfile.txt",
              "",
              "#####################################################################",
              "######################### COMMANDS (MAIN) ###########################",
              "#####################################################################",
              "quit        Quits lexed",
              "---------------------------------------------------------------------",
              "new         Create empty document",
              "---------------------------------------------------------------------",
              "load [file]",
              "",
              "            Loads file. If file name not given, file can be chosen",
              "            from a selection screen.",
              "---------------------------------------------------------------------",
              "read [file]",
              "   ",
              "            Loads file in 'read only' mode, editing not allowed. If",
              "            file name not given, file can be chosen from a selection",
              "            screen.",
              "---------------------------------------------------------------------",
              "save [file]",
              "",
              "            Saves file. Assumes current directory if not specified",
              "---------------------------------------------------------------------",
              "saveas      Opens confirmation window so filepath/name can be edited",
              "---------------------------------------------------------------------",
              "isave       Increments filename & saves (+1 to number before .ext)",
              "---------------------------------------------------------------------",
              "revert      Reverts file to last saved version",
              "---------------------------------------------------------------------",
              "saveprefs   Saves current settings",
              "---------------------------------------------------------------------",
              "help [module] or [class] or [function]",
              "",
              "            When no arguments given, opens HELP GUIDE. Otherwise",
              "            shows help or doc-string for given item.",
              "---------------------------------------------------------------------",
              "run         Attempts to run your python code in a separate window.",
              "            *Currently,this feature only works in Linux with",
              "            the GNOME TERMINAL.",
              "",
              "#####################################################################",
              "######################## COMMANDS (EDITING) #########################",

              "NOTE: most editing commands allow you to act on a single line number,",
              "multiple lines, a range of lines, selected lines only, marked lines",
              "only, or the current line if executed from the ENTRY WINDOW",
              "(control 'e').",
              "",
              "    examples:",
              "        To copy line 10                            ##copy 10",
              "        To copy multiple lines                     ##copy 10,15,20",
              "        To copy range                              ##copy 10-20",
              "        To copy marked lines                       ##copy marked",
              "        To copy selection (from ENTRY WINDOW)      ##copy selection",
              "        To copy selection (inline command only)    ##copy",
              "        To copy current line (ENTRY WINDOW only)   ##copy",
              "---------------------------------------------------------------------",
              "select [line] or [line1,line2,line3] or [start-end] or ['marked']",
              "or [function/class name] or ['all'] or ['up'] or ['down']",
              "",
              "            Select lines by line numbers, by function/class name,",
              "            or marked lines only.",
              "",
              "            Select up/down automatically selects all lines above",
              "            or below the current line, stopping when a blank line",
              "            is reached.",
              "",
              "            NOTE: using select automatically deselects the current",
              "            selection. You can not add to a selection.",
              "---------------------------------------------------------------------",
              "deselect [line] or [line1,line2,line3] or [start-end] or ['marked']",
              "or [function/class name] or ['all']",
              "",
              "            Deselect specified line(s)",
              "---------------------------------------------------------------------",
              "invert      Inverts selection",
              "---------------------------------------------------------------------",
              "copy [line] or [line1,line2,line3] or [start-end] or ['marked']",
              "or ['selection']",
              "",
              "            Copies line(s) into memory.",
              "---------------------------------------------------------------------",
              "paste [line]",
              "",
              "            Pastes previously copied text into document.",
              "            With no arguments, paste occurs at current line.",
              "            If line is given, paste occurs there (line inserted).",
              "            From ENTRY WINDOW, text is appended to current line.",
              "",
              "                example: ##paste 20",
              "---------------------------------------------------------------------",
              "delete [line] or [line1,line2,line3] or [start-end] or ['marked']",
              "or ['selection']",
              "",
              "            Deletes specified line(s)",
              "---------------------------------------------------------------------",
              "cut [line] or [line1,line2,line3] or [start-end] or ['marked']",
              "or ['selection']",
              "",
              "            Combines copy and delete into one operation.",
              "---------------------------------------------------------------------",
              "comment [line] or [line1,line2,line3] or [start-end] or ['marked']",
              "or ['selection']",
              "",
              "            Comments specified line(s)",
              "---------------------------------------------------------------------",
              "uncomment [line] or [line1,line2,line3] or [start-end] or ['marked']",
              "or ['selection']",
              "",
              "            Uncomments specified line(s)",
              "---------------------------------------------------------------------",
              "indent [line] or [line1,line2,line3] or [start-end] or ['marked']",
              "or ['selection']",
              "",
              "            Indents specified line(s)",
              "---------------------------------------------------------------------",
              "unindent [line] or [line1,line2,line3] or [start-end] or ['marked']",
              "or ['selection']",
              "",
              "            Unindents specified line(s)",
              "---------------------------------------------------------------------",
              "replace ['marked']['selected'] text1 with text2",
              "",
              "            Replaces occurrences of 'text1' with 'text2'. Can act on",
              "            all lines in document or marked/selected lines only",
              "",
              "                examples:",
              "                    ##replace cout with print",
              "                    ##replace marked true with True",
              "                    ##replace selected false with False",
              "---------------------------------------------------------------------",
              "timestamp   Appends current time & date to current line",
              "---------------------------------------------------------------------",
              "strip       Removes trailing whitespace from ALL lines",
              "---------------------------------------------------------------------",
              "undo        Rudimentary undo feature with 1 undo level",
              "",

              "#####################################################################",
              "######################## COMMANDS (NAVIGATION) ######################",
              "#####################################################################",
              "goto [line] or ['start'] or ['end'] or [function/class name]",
              "",
              "            Move to specified line number or function definition",
              "---------------------------------------------------------------------",
              "prev        Returns to previous line (no args)",
              "---------------------------------------------------------------------",
              "find [text]",
              "",
              "            Find specified text string and move to line containing it",
              "---------------------------------------------------------------------",
              "mark [line] or [line1,line2,line3] or [start-end] or [text]",
              "",
              "            Marks/highlights lines with specified text or specified",
              "            line numbers.",
              "---------------------------------------------------------------------",
              "unmark [line] or [line1,line2,line3] or [start-end] or [text] or [all]",
              "",
              "            Unmarks line(s) that are marked. Use 'unmark all' to",
              "            unmark the entire document.",
              "---------------------------------------------------------------------",
              "collapse [line] or [line1,line2,line3] or [start-end] or ['functions']",
              "         or ['all'] or ['tab' number] or ['marked'] or ['selection']",
              "",
              "            Collapses lines with greater indentation than specified",
              "            line(s). Simplifies navigation by hiding the details.",
              "            It can even collapse lines with a specified indentation.",
              "                example: ##collapse tab 2",
              "---------------------------------------------------------------------",
              "expand [line] or [line1,line2,line3] or [start-end] or ['all'] or",
              "        ['marked'] or ['selection']",
              "",
              "            Expands (uncollapses) specified line(s). Use 'expand all'",
              "            to expand all lines.",
              "",

              "#####################################################################",
              "###################### COMMANDS (SETTINGS) ##########################",
              "#####################################################################",
              "NOTE: Changes not saved to settings file until 'saveprefs' is used!",
              "      Some settings can alternatively be changed by using the",
              "      commands 'show' & 'hide'.",
              "---------------------------------------------------------------------",
              "syntax [on/off]",
              "(show/hide syntax)",
              "",
              "            Toggles syntax highlighting",
              "---------------------------------------------------------------------",
              "debug [on/off]",
              "(show/hide bugs)",
              "",
              "            Toggles debug mode. Lines with errors marked with ##!",
              "---------------------------------------------------------------------",
              "formatting [on/off]",
              "(show/hide formatting)",
              "",
              "            Toggles comment formatting",
              "---------------------------------------------------------------------",
              "whitespace [on/off]",
              "(show/hide whitespace)",
              "",
              "           Toggles visible whitespace",
              "---------------------------------------------------------------------",
              "tabs [on/off]",
              "(show/hide tabs)",
              "",
              "           Toggles visible indentation (tabs)",
              "---------------------------------------------------------------------",
              "entry [on/off]",
              "(show/hide entry)",
              "",
              "           Toggles entry highlighting (highlights the current line being",
              "           edited)",
              "---------------------------------------------------------------------",
              "live [on/off]",
              "(show/hide live)",
              "",
              "           Toggles live (real-time) syntax highlighting on entry line",
              "---------------------------------------------------------------------",
              "split [on/off] or [line]",
              "(show/hide splitscreen)",
              "",
              "           Toggles splitscreen. If a line number is the argument,",
              "           splitscreen display begins at that line",
              "---------------------------------------------------------------------",
              "pageguide [on/off] or [number]",
              "(show/hide guide)",
              "",
              "              Toggles page guide. If a number is the argument,",
              "              guide occurs after that number of characters.",
              "              The default page guide is 80 characters wide.",
              "",
              "              NOTE: Terminal width must be at least 88 characters",
              "              to view 80 character page guide!",
              "---------------------------------------------------------------------",
              "protect [on/off] or ['with' text]",
              "",
              "           Toggles command protection and can optionally change",
              "           protect string.",
              "",
              "                example: ##protect with ::",
              "---------------------------------------------------------------------",
              "commands [on/off]",
              "",
              "            Toggles inline (live) commands.",
              "            When off, ENTRY WINDOW is the ONLY way to enter commands.",
              "---------------------------------------------------------------------",
              "auto [on/off]",
              "",
              "            Toggles automation of settings. When on, automatically",
              "            adjusts settings to match file type.",
              "            '.py' - debug mode on, syntax highlighting on, protect off",
              "            other - debug off, syntax highlighting off, protect on",
              "---------------------------------------------------------------------",
              "acceleration [on/off]",
              "",
              "            Toggles cursor acceleration. While on, cursor speed",
              "            increases over time as you hold down the arrow keys.",
              "---------------------------------------------------------------------",
              "color on    Manually start color if supported by your terminal",
              "---------------------------------------------------------------------",
              "color default",
              "",
              "            Set colors to their default values",
              "---------------------------------------------------------------------",
              "setcolors   Opens selection screen to allow you to set colors used",
              "            with syntax highlighting",
              "",

              "#####################################################################",
              "######################## SPECIAL FEATURES ###########################",
              "#####################################################################",
              "HELP",
              "    Similar to the help() feature in the python interpreter, attempts",
              "    to show the help file/doc string for given module, class, or",
              "    function. Can only show help for imported modules and classes &",
              "    functions defined within your code.",
              "",
              "    Navigate up/down using up and down arrow keys, or the 'b' key",
              "    and spacebar. Left & right arrows will change 'pages'.",
              "    Press 's' to go to the start of the document.",
              "    Press 'e' to go to the end.",
              "    Press 'q' to quit (or any key if help is less than one page).",
              "",
              "    example:",
              "            ##import os",
              "            ##help os",
              "            ##help os.path.exists",
              "---------------------------------------------------------------------",
              "DEBUG MODE",
              "    Realtime python debugging. While it won't catch all errors, it",
              "    should flag simple errors such as incorrect use of the comparison",
              "    operator '==' or forgetting to indent when necessary.",
              "",
              "    DEBUG MODE (as well as syntax highlighting) can be processor",
              "    intensive and should be turned off on older machines to improve",
              "    performance.",
              "---------------------------------------------------------------------",
              "COMMENT FORMATTING",
              "    When on, '#' is a regular comment, '##' is a formatted comment.",
              "    Formats:",
              "        '##TEXT' - Left Justified",
              "##Hello World",
              "        '###TEXT' - Right Justified",
              "###Hello World",
              "        '##TEXT##' - Centered",
              "##Hello World##",
              "        '##='  - Separator (fills line with last character)",
              "##=",
              "        '##' - empty (same color as centered)",
              "###",
              "        '....##TEXT' - Comment Block (after indent or other characters)",
              "    ##BLOCK OF TEXT",
              "---------------------------------------------------------------------",
              "READ MODE",
              "    In Read Mode, file can be viewed but not edited. Debugging and",
              "    syntax highlighting (save for comment formatting) are turned off.",
              "    Navigate up/down using up and down arrow keys, or the 'b' key",
              "    and spacebar. Left & right arrows will change 'pages'.",
              "    Press 's' to go to the start of the document.",
              "    Press 'e' to go to the end.",
              "    Press 'q' to quit.",
              "---------------------------------------------------------------------",
              "ENCRYPTION",
              "    When saving, you can choose to save a password protected file with",
              "    basic encryption (in theory, the longer the password the better",
              "    the encryption). Simply save with the extension '.pwe', short for",
              "    'lexed encryption'.",
              "",
              "        NOTE: It is recommended that you save a non-encrypted version",
              "        of your file first. If you forget your password or something",
              "        goes wrong during the encryption process, your file will not",
              "        be recoverable! No guarantees are made as to the strength of",
              "        the encryption, ##USE AT YOUR OWN RISK!",
              "",

              "#####################################################################",
              "############################## FLAGS ################################",
              "#####################################################################",
              "lexed [OPTIONS] [FILENAME]",
              "",
              "-t, --text      Open in text mode with protection on",
              "-s, --string    Sets protection string (and turns protection on)",
              "-p, --python    Open in python mode with syntax and debugging on",
              "-c, --color     Open in color mode with default colors",
              "-m, --mono      Open in monochrome mode",
              "-i, --inverted  Open in monochrome mode with inverted display",
              "-n, --nobold    Turns off bold text",
              "-r, --read      Opens specified file in 'read only' mode",
              "-h, --help      Display Help Guide",
              "",
              "        example:",
              "            ##lexed --text --string '::' ~/Desktop/myfile.txt",
              "",
              "####################### Last edited on 07/22/08 01:05:49 PM (Tuesday)"]
